program Test;

uses
  Windows,
  BiosHelp in 'BiosHelp.pas';

{$E exe}

{$R Icon.res}

const
  CRLF = #$0D#$0A;

function MyMessageBox(const Text: string; Icon: DWORD): LongBool;
var
  Params: TMsgBoxParams;
begin
  FillChar(Params, SizeOf(TMsgBoxParams), 0);
  with Params do
  begin
    cbSize := SizeOf(TMsgBoxParams);
    hwndOwner := GetDesktopWindow;
    hInstance := SysInit.HInstance;
    lpszText := PChar(Text);
    lpszCaption := 'BiosHelp sample';
    if (Icon <> 0) then
      dwStyle := Icon
    else
    begin
      dwStyle := MB_USERICON;
      lpszIcon := MakeIntResource(555);
    end;
  end;
  Result := MessageBoxIndirect(Params);
end;


const
  // Well known offsets... (only date seems to be always available)
  RomBiosDateOffset      = Pointer($000FFFF5);
  RomBiosNameOffset      = Pointer($000FE061);
  RomBiosCopyrightOffset = Pointer($000FE091); 
  RomBiosIdOffset        = Pointer($000FEC71);
  
var
  Dump: TRomBiosDump;

begin
  if ReadRomBios(Dump, rrbmAutomatic) then
  begin
    MyMessageBox(
      'Your BIOS-Date: ' + GetRomBiosString(Dump, RomBiosDateOffset) + CRLF +
      CRLF +
      'Get BIOS info on Windows 95/98/SE/ME/NT/2K/XP' + CRLF +
      'with BiosHelp.pas for Delphi 4.03/5.01/6.01' + CRLF +
      CRLF +
      'Written 2001 by Nico Bendlin (nico@bendlin.de)', 0)
  end
  else
    MyMessageBox('Error on reading BIOS!', MB_ICONERROR);
end.
